Attribute VB_Name = "modAppCode"
Option Explicit

Function Str2Null(sStr As String) As String
   If Trim$(sStr) = "" Then
      Str2Null = "Null"
   Else
      Str2Null = "'" & Trim$(sStr) & "'"
   End If
End Function

Sub AppGetEnv()
   Dim sReturnStr As String
   Dim iLen As Integer
   Dim sDataLoc As String
   Dim bToolBar As Integer
   Dim bStatusBar As Integer
   Dim sIniName As String
   
   ' Build INI File Name From EXE Name
   sIniName = App.Path & "\" & App.EXEName & ".INI"
   
   ' Retreive Logon Name
   sReturnStr = Space$(81)
   iLen = GetPrivateProfileString("Logon", "UserName", "", sReturnStr, Len(sReturnStr), sIniName)
   gsLoginID = Left$(sReturnStr, iLen)
   
   ' Retrieve Data Location
   sReturnStr = Space$(81)
   iLen = GetPrivateProfileString("DataSource", "DataLoc", "", sReturnStr, Len(sReturnStr), sIniName)
   sDataLoc = Left$(sReturnStr, iLen)

   ' Retrieve Data Source Name
   sReturnStr = Space$(81)
   iLen = GetPrivateProfileString(sDataLoc, "DSN", "", sReturnStr, Len(sReturnStr), sIniName)
   gsDSN = Left$(sReturnStr, iLen)

   ' Retrieve Database Name
   sReturnStr = Space$(144)
   iLen = GetPrivateProfileString(sDataLoc, "DBName", "", sReturnStr, Len(sReturnStr), sIniName)
   gsDatabase = Left$(sReturnStr, iLen)

   ' Get Server Flag
   gbServer = GetPrivateProfileInt(sDataLoc, "DBServer", False, sIniName)
   giPassThru = IIf(gbServer, 64, 0)
   
   ' Display Error System
   gbErrors = GetPrivateProfileInt("AppEnv", "Errors", True, sIniName)

   ' Is ToolBar Visible ?
   bToolBar = GetPrivateProfileInt("AppEnv", "ToolBar", True, sIniName)
   frmMain!pnlToolBar.Visible = bToolBar
   frmMain!mnuVTool.Checked = bToolBar
   
   ' Is StatusBar Visible ?
   bStatusBar = GetPrivateProfileInt("AppEnv", "StatusBar", True, sIniName)
   frmMain!pnlStatusBar.Visible = bStatusBar
   frmMain!mnuVStatus.Checked = bStatusBar
End Sub

Sub AppQuit()
   Call ODBCUnload(gldbc, glEnv)
   End
End Sub




Function ErrHandler(iErr As Integer) As Integer
   MsgBox "Error Number Is " & iErr & Chr$(13) & Chr$(10) & Error$
End Function

Sub FormCenterModal(frmCurrent As Form)
   frmCurrent.Left = (Screen.Width - frmCurrent.Width) / 2
   frmCurrent.Top = (Screen.Height - frmCurrent.Height) / 2
End Sub

Function FormCheckKey(KeyCode As Integer, Shift As Integer) As Integer
   ' If Alt key is pressed, continue to next keystroke
   If Shift = 4 Then
      Exit Function
   End If

   FormCheckKey = False
   If KeyCode = KEY_DELETE Or KeyCode = KEY_BACK Or (KeyCode > 31 And KeyCode < 256) Then
      If KeyCode >= 37 And KeyCode <= 40 Then
         ' Right, Left, Up And Down Arrows
      Else
         ' For all text fields, combo boxes, etc.
         ' If there are any changes, set dirty flag
         If TypeOf Screen.ActiveControl Is TextBox Then
            FormCheckKey = True
         ElseIf TypeOf Screen.ActiveControl Is ComboBox Then
            ' If Style is 2, allow search for letters
            If Screen.ActiveControl.Style <> 2 Then
               FormCheckKey = True
            End If
         ElseIf TypeOf Screen.ActiveControl Is CheckBox Then
            FormCheckKey = True
         End If
      End If
   End If
End Function

Function FormCheckUnload(frmName As Form) As Integer
   Dim iResponse As Integer

   If frmName.WindowState = MINIMIZED Then
      frmName.WindowState = NORMAL
   End If
   frmName.ZOrder 0

   iResponse = MsgBox("Data Has Been Changed" & Chr(13) & Chr(10) & "Save Changes ?", MB_ICONQUESTION + MB_YESNOCANCEL, frmName.Caption)
   FormCheckUnload = iResponse
End Function

Sub Main()
   Dim iTemp As Integer

   Screen.MousePointer = HOURGLASS
   
   ' Get INI Parameters
   Call AppGetEnv
   gsAppCode = APP_CODE

   ' Display Main Form
   frmMain.Show

   ' Display Login Form
   frmLogin.Show MODAL

   ' Did the user login correctly ?
   If gbValidLogon Then
      
      frmItemList.Show
   Else
      End
   End If

   Screen.MousePointer = DEFAULT
End Sub

