Attribute VB_Name = "modODBCAPI"
Option Explicit

''''''''''''''''
' Connection Management Constants and Data Structures
Global gldbc As Long
Global glEnv As Long
Global gasStates() As String

Global Const MAX_DATA_BUFFER = 255

''''''''''''''''
' ODBC Declarations and Constants
Global Const SQL_SUCCESS = 0
Global Const SQL_SUCCESS_WITH_INFO = 1
Global Const SQL_ERROR = -1
Global Const SQL_NO_DATA_FOUND = 100
Global Const SQL_CLOSE = 0
Global Const SQL_DROP = 1
Global Const SQL_CHAR = 1
Global Const SQL_NUMERIC = 2
Global Const SQL_DECIMAL = 3
Global Const SQL_INTEGER = 4
Global Const SQL_SMALLINT = 5
Global Const SQL_FLOAT = 6
Global Const SQL_REAL = 7
Global Const SQL_DOUBLE = 8
Global Const SQL_VARCHAR = 12
Global Const SQL_DATA_SOURCE_NAME = 6
Global Const SQL_USER_NAME = 8

' The hWnd is a Long in Windows 95 & Windows NT
#If Win32 Then
   Declare Function SQLAllocEnv Lib "odbc32.dll" (env As Long) As Integer
   Declare Function SQLFreeEnv Lib "odbc32.dll" (ByVal env As Long) As Integer
   
   Declare Function SQLAllocConnect Lib "odbc32.dll" (ByVal env As Long, ldbc As Long) As Integer
   Declare Function SQLConnect Lib "odbc32.dll" (ByVal ldbc As Long, ByVal Server As String, ByVal serverlen As Integer, ByVal uid As String, ByVal uidlen As Integer, ByVal pwd As String, ByVal pwdlen As Integer) As Integer
   Declare Function SQLDriverConnect Lib "odbc32.dll" (ByVal ldbc As Long, ByVal hWnd As Long, ByVal szCSIn As String, ByVal cbCSIn As Integer, ByVal szCSOut As String, ByVal cbCSMax As Integer, cbCSOut As Integer, ByVal f As Integer) As Integer
   
   Declare Function SQLFreeConnect Lib "odbc32.dll" (ByVal ldbc As Long) As Integer
   Declare Function SQLDisconnect Lib "odbc32.dll" (ByVal ldbc As Long) As Integer
   Declare Function SQLAllocStmt Lib "odbc32.dll" (ByVal ldbc As Long, lStmt As Long) As Integer
   Declare Function SQLFreeStmt Lib "odbc32.dll" (ByVal lStmt As Long, ByVal EndOption As Integer) As Integer
   Declare Function SQLTables Lib "odbc32.dll" (ByVal lStmt As Long, ByVal q As Long, ByVal cbq As Integer, ByVal o As Long, ByVal cbo As Integer, ByVal t As Long, ByVal cbt As Integer, ByVal tt As Long, ByVal cbtt As Integer) As Integer
   
   Declare Function SQLExecDirect Lib "odbc32.dll" (ByVal lStmt As Long, ByVal sqlString As String, ByVal sqlstrlen As Long) As Integer
   Declare Function SQLNumResultCols Lib "odbc32.dll" (ByVal lStmt As Long, NumCols As Integer) As Integer
   Declare Function SQLDescribeCol Lib "odbc32.dll" (ByVal lStmt As Long, ByVal colnum As Integer, ByVal colname As String, ByVal Buflen As Integer, colnamelen As Integer, dtype As Integer, dl As Long, ds As Integer, n As Integer) As Integer
   Declare Function SQLFetch Lib "odbc32.dll" (ByVal lStmt As Long) As Integer
   Declare Function SQLGetData Lib "odbc32.dll" (ByVal lStmt As Long, ByVal col As Integer, ByVal wConvType As Integer, ByVal lpbBuf As String, ByVal dwbuflen As Long, lpcbout As Long) As Integer
   Declare Function SQLGetInfo Lib "odbc32.dll" (ByVal ldbc As Long, ByVal hWnd As Long, ByVal szInfo As String, ByVal cbInfoMax As Integer, cbInfoOut As Integer) As Integer
   Declare Function SQLError Lib "odbc32.dll" (ByVal env As Long, ByVal ldbc As Long, ByVal lStmt As Long, ByVal SQLState As String, NativeError As Long, ByVal Buffer As String, ByVal Buflen As Integer, Outlen As Integer) As Integer
#Else
   Declare Function SQLAllocEnv Lib "odbc.dll" (env As Long) As Integer
   Declare Function SQLFreeEnv Lib "odbc.dll" (ByVal env As Long) As Integer
   
   Declare Function SQLAllocConnect Lib "odbc.dll" (ByVal env As Long, ldbc As Long) As Integer
   Declare Function SQLConnect Lib "odbc.dll" (ByVal ldbc As Long, ByVal Server As String, ByVal serverlen As Integer, ByVal uid As String, ByVal uidlen As Integer, ByVal pwd As String, ByVal pwdlen As Integer) As Integer
   Declare Function SQLDriverConnect Lib "odbc.dll" (ByVal ldbc As Long, ByVal hWnd As Integer, ByVal szCSIn As String, ByVal cbCSIn As Integer, ByVal szCSOut As String, ByVal cbCSMax As Integer, cbCSOut As Integer, ByVal f As Integer) As Integer
   
   Declare Function SQLFreeConnect Lib "odbc.dll" (ByVal ldbc As Long) As Integer
   Declare Function SQLDisconnect Lib "odbc.dll" (ByVal ldbc As Long) As Integer
   Declare Function SQLAllocStmt Lib "odbc.dll" (ByVal ldbc As Long, lStmt As Long) As Integer
   Declare Function SQLFreeStmt Lib "odbc.dll" (ByVal lStmt As Long, ByVal EndOption As Integer) As Integer
   Declare Function SQLTables Lib "odbc.dll" (ByVal lStmt As Long, ByVal q As Long, ByVal cbq As Integer, ByVal o As Long, ByVal cbo As Integer, ByVal t As Long, ByVal cbt As Integer, ByVal tt As Long, ByVal cbtt As Integer) As Integer
   
   Declare Function SQLExecDirect Lib "odbc.dll" (ByVal lStmt As Long, ByVal sqlString As String, ByVal sqlstrlen As Long) As Integer
   Declare Function SQLNumResultCols Lib "odbc.dll" (ByVal lStmt As Long, NumCols As Integer) As Integer
   Declare Function SQLDescribeCol Lib "odbc.dll" (ByVal lStmt As Long, ByVal colnum As Integer, ByVal colname As String, ByVal Buflen As Integer, colnamelen As Integer, dtype As Integer, dl As Long, ds As Integer, n As Integer) As Integer
   Declare Function SQLFetch Lib "odbc.dll" (ByVal lStmt As Long) As Integer
   Declare Function SQLGetData Lib "odbc.dll" (ByVal lStmt As Long, ByVal col As Integer, ByVal wConvType As Integer, ByVal lpbBuf As String, ByVal dwbuflen As Long, lpcbout As Long) As Integer
   Declare Function SQLGetInfo Lib "odbc.dll" (ByVal ldbc As Long, ByVal hWnd As Integer, ByVal szInfo As String, ByVal cbInfoMax As Integer, cbInfoOut As Integer) As Integer
   Declare Function SQLError Lib "odbc.dll" (ByVal env As Long, ByVal ldbc As Long, ByVal lStmt As Long, ByVal SQLState As String, NativeError As Long, ByVal Buffer As String, ByVal Buflen As Integer, Outlen As Integer) As Integer
#End If

Function ODBCAccessDate(sDate As String) As String
   ODBCAccessDate = Mid$(sDate, 6, 2) & "/" & Mid$(sDate, 9, 2) & "/" & Mid$(sDate, 3, 2)
End Function

Function ODBCData(lStmt As Long, iColumn As Integer) As String
   Dim iStatus As Integer
   Dim sData As String * MAX_DATA_BUFFER
   Dim lOutLen As Long

   iStatus = SQLGetData(lStmt, iColumn, 1, sData, MAX_DATA_BUFFER, lOutLen)
   If lOutLen = -1 Then
      ODBCData = ""
   Else
      ODBCData = Left$(sData, lOutLen)
   End If
End Function

Function ODBCDataOpen(ldbc As Long) As Integer
   Dim sResult As String
   Dim iSize As Integer
   Dim sConnect As String
   
   On Error GoTo ODBCDataOpen_EH
   
   ODBCDataOpen = False

   sConnect = "DSN=" & gsDSN
   sConnect = sConnect & ";UID=" & gsLoginID
   sConnect = sConnect & ";PWD=" & gsPassword
   sConnect = sConnect & ";APP=" & gsAppCode
   sConnect = sConnect & ";DATABASE=" & gsDatabase
   If SQLDriverConnect(ldbc, Screen.ActiveForm.hWnd, sConnect, Len(sConnect), sResult, Len(sResult), iSize, 1) <= 0 Then
      MsgBox "Could not establish connection to ODBC driver!"
      Exit Function
   End If
   
   ODBCDataOpen = True

   Exit Function

ODBCDataOpen_EH:
   Dim iAction As Integer
   iAction = ErrHandler(Err)
   gbValidLogon = False
   Exit Function
End Function

Function ODBCInit(lEnv As Long, ldbc As Long) As Integer
   Dim iStatus As Integer

   ODBCInit = True

   ' This ODBC call checks to see if the libraries are
   ' present and if we can load them into memory
   ' and establish a memory area for them to work in.
   If SQLAllocEnv(lEnv) <> 0 Then
      MsgBox "Unable to initialize ODBC API drivers!"
      ODBCInit = False
      End
   End If
   
   ' This Call establishes a memory area where we can
   ' put login information that will be used to login
   ' to our data source. The area for the login
   ' information is contained in the ldbc variable.
   If SQLAllocConnect(lEnv, ldbc) <> 0 Then
      MsgBox "Could not allocate memory for connection Handle!"
      ODBCInit = False
      ' Free the Environment
      iStatus = SQLFreeEnv(lEnv)
      If iStatus = SQL_ERROR Then
         MsgBox "Error Freeing Environment From ODBC Drivers"
      End If

      ' Quit the Application
      End
   End If
End Function

Function ODBCQuerySubmit(ldbc As Long, lStmt As Long, sSQL As String) As Integer
   Dim lRet As Long
   Dim lErrNo As Long
   Dim iLen As Integer
   Dim sSQLState As String * MAX_DATA_BUFFER
   Dim sErrorMsg As String * MAX_DATA_BUFFER
   Dim sMsg As String
   ODBCQuerySubmit = True
   
   If SQLAllocStmt(ldbc, lStmt) <> 0 Then
      MsgBox "Could not allocate memory for a statement handle!"
      ODBCQuerySubmit = False
      Exit Function
   End If
   
   If SQLExecDirect(lStmt, sSQL, Len(sSQL)) <> SQL_SUCCESS Then
      lRet = SQLError(glEnv, ldbc, lStmt, sSQLState, lErrNo, sErrorMsg, MAX_DATA_BUFFER, iLen)
      sMsg = "Error Executing SQL Statement" & Chr$(13) & Chr$(10)
      sMsg = sMsg & "ODBC State = " & Trim$(Left$(sSQLState, InStr(sSQLState, Chr$(0)) - 1)) & Chr$(13) & Chr$(10)
      sMsg = sMsg & "ODBC Error Message = " & Left$(sErrorMsg, iLen)
      MsgBox sMsg, , "ODBCQuerySubmit()"
      ODBCQuerySubmit = False
   End If
End Function


Function ODBCTableIdGet(sTable As String) As Long
   Const nNEXT_ID% = 1
   
   Dim iStatus As Integer
   Dim sSQL As String
   Dim lStmt As Long
   Dim sReturn As String
   
   If gbErrors Then
      On Error GoTo ODBCTableIdGet_EH
   End If

   Screen.MousePointer = HOURGLASS
   
   sSQL = "SELECT lNext_id FROM tblTableIDs WHERE szTable_nm = '" & sTable & "'"
   iStatus = ODBCQuerySubmit(gldbc, lStmt, sSQL)
   iStatus = SQLFetch(lStmt)
   sReturn = ODBCData(lStmt, nNEXT_ID)
   
   ODBCTableIdGet = CLng(sReturn)
   iStatus = SQLFreeStmt(lStmt, SQL_DROP)
      
   sSQL = "UPDATE tblTableIDs "
   sSQL = sSQL & "SET lNext_id = lNext_id + 1 "
   sSQL = sSQL & "WHERE szTable_nm = '" & sTable & "'"
   iStatus = ODBCQuerySubmit(gldbc, lStmt, sSQL)
   iStatus = SQLFreeStmt(lStmt, SQL_DROP)

   Exit Function
   
ODBCTableIdGet_EH:
   Dim iAction As Integer
   iAction = ErrHandler(Err)
   Exit Function
End Function

Sub ODBCUnload(ldbc As Long, lEnv As Long)
   Dim iStatus As Integer

   If ldbc <> 0 Then
      iStatus = SQLDisconnect(ldbc)
      If iStatus = SQL_ERROR Then
         MsgBox "Error logging out of data source!"
      End If
   End If
   
   iStatus = SQLFreeConnect(ldbc)
   If iStatus = SQL_ERROR Then
      MsgBox "Error unloading ODBC drivers!"
   End If

   If lEnv <> 0 Then
      iStatus = SQLFreeEnv(lEnv)
      If iStatus = SQL_ERROR Then
         MsgBox "Error Freeing Environment From ODBC Drivers"
      End If
   End If
End Sub

