Attribute VB_Name = "modStatus"
'******************************************************************
'* Module Name : S_Status.bas
'* Purpose     : Routines for the status bar on the MDI form
'* Tables Used : None
'*
'* Description :
'* This module contains routines for manipulating the Status
'* bar on the main MDI form.
'******************************************************************
Option Explicit

Sub FormCenter(frmCurrent As Form)
   frmCurrent.Left = (Screen.Width / 2 - frmCurrent.Width / 2)
   frmCurrent.Top = (Screen.Height / 2 - frmCurrent.Height / 2)
End Sub

Sub StatusIDShow(sMsg As String)
   frmMain!pnlScrID.Caption = " " & sMsg
End Sub

Sub StatusMsgShow(ByVal sMessage As String)
   frmMain!pnlStatusBox.Caption = " " & sMessage
End Sub

Sub StatusMsgToggle()
   If frmMain!pnlStatusBar.Visible Then
      frmMain!pnlStatusBar.Visible = False
      frmMain!mnuVStatus.Checked = False
   Else
      frmMain!pnlStatusBar.Visible = True
      frmMain!mnuVStatus.Checked = True
   End If
End Sub

Function StatusProcess(sMsg As String)
   Screen.MousePointer = HOURGLASS
   StatusProcess = StatusSave()

   Call StatusMsgShow(sMsg)
End Function

Sub StatusRestore(ByVal sMsg As String)
   ' Split Msg String into Message & ID
   Call StatusMsgShow(Left$(sMsg, InStr(sMsg, Chr$(0)) - 1))
   Call StatusIDShow(Mid$(sMsg, InStr(sMsg, Chr$(0)) + 1))
   If Screen.MousePointer = HOURGLASS Then
      Screen.MousePointer = DEFAULT
   End If
End Sub

Function StatusSave() As String
   ' Get the two values and pack into one string
   StatusSave = Trim$(frmMain!pnlStatusBox.Caption) & Chr$(0) & Trim$(frmMain.pnlScrID.Caption)
End Function

Sub ToolBarToggle()
   If frmMain!pnlToolBar.Visible Then
      frmMain!pnlToolBar.Visible = False
      frmMain!mnuVTool.Checked = False
   Else
      frmMain!pnlToolBar.Visible = True
      frmMain!mnuVTool.Checked = True
   End If
End Sub

